dwg.ru forum rss xml
| Правила | Регистрация | Пользователи | Поиск | Сообщения за день | Все разделы прочитаны |  Справка по форуму |

Вернуться   Форум DWG.RU > Программное обеспечение > Программирование > LISP > Научите лиспу на примере (или как kpblc, VVA и компания пытаются обучить чайника лиспу)

Научите лиспу на примере (или как kpblc, VVA и компания пытаются обучить чайника лиспу)

Версия для печати
 
Ответ
Опции темы Поиск в этой теме
Непрочитано 20.07.2008, 20:12
Научите лиспу на примере (или как kpblc, VVA и компания пытаются обучить чайника лиспу)
Red Nova
 
ՃԱՐՏԱՐԱԳԵՏ, Տ.Գ.Թ.
 
Торонто
Регистрация: 23.10.2007
Сообщений: 1,952
Отправить сообщение для Red Nova с помощью Skype™

Red Nova вне форума Вставить имя

Со школы не ладится у меня с программированием. Все предметы щелкал, а на экзамене по информатике (Visual foxpro) программку типа суммирования столбцов списал у соседа (это уже в университете).
Не смотря на эте намерен научится писать программы для Автокада на лиспе, скачал книгу Хювенена, несколько примеров создания программ, но после получасового “смотрения” таких книг мое мышление явно притормаживает.
Решил пойти другим путем.
Нашел самый короткий лисп из моей коллекции, и прошу программистов с этого форума пошагово объяснить какой символ что означает. Надеюсь на вашу помощь.


Код:
[Выделить все]
(defun c:make-blocks-explodeable (/ adoc)
  (vl-load-com)
  (vla-startundomark
    (setq adoc (vla-get-activedocument (vlax-get-acad-object)))
    ) ;_ end of vla-startundomark
  (vlax-for blk_def (vla-get-blocks adoc)
    (if (and (equal (vla-get-isxref blk_def) :vlax-false)
             (equal (vla-get-islayout blk_def) :vlax-false)
             ) ;_ end of and
      (vl-catch-all-apply '(lambda () (vla-put-explodable blk_def :vlax-true)))
      ) ;_ end of if
    ) ;_ end of vlax-for
  (vla-endundomark adoc)
  (princ)
  ) ;_ end of defun
_____________________________________________________________________________________________________________

Прошло много лет и топик теперь представляет из себя площадку для обучения азов программирования для многих начинающих.
Так что начинающие лиспогрызы приветствуются .
__________________
Блог

Последний раз редактировалось Red Nova, 12.07.2017 в 05:43.
Просмотров: 1226246
 
Непрочитано 21.07.2008, 16:26
#21
Кулик Алексей aka kpblc
Moderator

LISP, C# (ACAD 200[9,12,13,14])
 
Регистрация: 25.08.2003
С.-Петербург
Сообщений: 34,811


Так не покатит (на форуме уже пробовали, простых путей там нет). Получение через ActiveX будет иметь смысл только при работе с файлом, содержащим внешние ссылки (из которых тоже надо будет получать выноски).
Код:
[Выделить все]
(defun c:get-notes-activex (/ adoc lst)
;; Через ActiveX
  (vl-load-com)
  (vla-startundomark
    (setq adoc (vla-get-activedocument (vlax-get-acad-object)))
    ) ;_ end of vla-StartUndoMark
  (vlax-for ent (vla-get-modelspace adoc)
    (if (= (vla-get-objectname ent) "mcsDbObjectNotePosition")
      (setq lst (cons ent lst))
      ) ;_ end of if
    ) ;_ end of vlax-for
  ;; Теперь делай со списком чего хотишь
  (vla-endundomark adoc)
  (princ)
  ) ;_ end of defun

(defun c:get-notes-ent (/ adoc lst _dwgru-conv-pickset-to-list)
;; Через ent*

  (defun _dwgru-conv-pickset-to-list (value / tab item)
    (repeat (setq tab  nil
                  item (sslength value)
                  ) ;_ end setq
      (setq tab (cons (ssname value (setq item (1- item))) tab))
      ) ;_ end repeat
    ) ;_ end defun

  (vl-load-com)
  (vla-startundomark
    (setq adoc (vla-get-activedocument (vlax-get-acad-object)))
    ) ;_ end of vla-StartUndoMark
  (setq lst (vl-remove-if-not
              '(lambda (x) (= (cdr (assoc 0 (entget x))) "spdsNotePosition"))
              (_dwgru-conv-pickset-to-list (ssget "_X"))
              ) ;_ end of vl-remove-if-not
        ) ;_ end of setq
  ;; Теперь делай со списком чего хотишь
  (vla-endundomark adoc)
  (princ)
  ) ;_ end of defun
__________________

---
Обращение ко мне - на "ты".
Все, что сказано - личное мнение.
Кулик Алексей aka kpblc вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Автор темы   Непрочитано 21.07.2008, 17:42
#22
Red Nova

ՃԱՐՏԱՐԱԳԵՏ, Տ.Գ.Թ.
 
Регистрация: 23.10.2007
Торонто
Сообщений: 1,952
Отправить сообщение для Red Nova с помощью Skype™


Нам Xref не надо, так что через ent*.
Но давай не торопиться.
Попытаюсь переварить.
Цитата:
(defun _dwgru-conv-pickset-to-list (value / tab item)
Тут понятно, dwgru-conv-pickset-to-list - команда вызова (в скобках)
value - Входящие параметры
tab item - локальные переменные

Потом что-то не понятное...

Потом опять что-то понял
Цитата:
(vl-load-com)
(vla-startundomark
(setq adoc (vla-get-activedocument (vlax-get-acad-object)))
(vl-load-com)-Загружаем Active-X
(vla-startundomark - Начальная метка для Undo
(setq adoc (vla-get-activedocument (vlax-get-acad-object)))
- Назначить переменной adoc чего-то там

Ну и дальше много разных непонятных букв

Можно разжувать?
__________________
Блог

Последний раз редактировалось Red Nova, 22.07.2008 в 10:45.
Red Nova вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Непрочитано 21.07.2008, 23:08
#23
Кулик Алексей aka kpblc
Moderator

LISP, C# (ACAD 200[9,12,13,14])
 
Регистрация: 25.08.2003
С.-Петербург
Сообщений: 34,811


_dwgru-conv-pickset-to-list - функция, преобразовывающая набор примитивов в список, который уже можно обрабатывать через foreach или mapcar. Там все достаточно просто: определяется длина набора (n), и это количество раз повторяется: добавить в список n-ный элемент набора; n уменьшить на 1.
Строки
Код:
[Выделить все]
(setq lst (vl-remove-if-not
              '(lambda (x) (= (cdr (assoc 0 (entget x))) "spdsNotePosition"))
              (_dwgru-conv-pickset-to-list (ssget "_X"))
              ) ;_ end of vl-remove-if-not
        )
можно перевести так:
переменной lst присвоить список, полученный из набора. Предварительно из списка исключить все элементы, у которых тип (хранится в DXF-коде 0) не равен "spdsNotePosition".
__________________

---
Обращение ко мне - на "ты".
Все, что сказано - личное мнение.
Кулик Алексей aka kpblc вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Автор темы   Непрочитано 22.07.2008, 10:42
#24
Red Nova

ՃԱՐՏԱՐԱԳԵՏ, Տ.Գ.Թ.
 
Регистрация: 23.10.2007
Торонто
Сообщений: 1,952
Отправить сообщение для Red Nova с помощью Skype™


А можно медленнее?
Я пытался написать свои предположения, но наверное не стоит, там все равно больше вопросов чем понятного.
Когда будет свободное время напиши пожалуйста пояснение как в посте #5.
__________________
Блог
Red Nova вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Непрочитано 22.07.2008, 11:51
1 | #25
VVA

Инженер LISP
 
Регистрация: 11.05.2005
Минск
Сообщений: 6,542
Отправить сообщение для VVA с помощью ICQ Отправить сообщение для VVA с помощью Skype™


Red Nova, Не с того конца подходишь. Для тебя пока vl-* и vla-* функции табу. Задание попроще:
1. Название команды - Колонна
2. Запрашивается у пользователя длина A и ширина B
3. Запрашивается точка вставки Pt
4. Точка вставки Pt считается центром прямоугольника AxB
Пиши команду, рисующую колонну. Как минимум на одни грабли наступишь.
__________________
Как использовать код на Лиспе читаем здесь
VVA вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Непрочитано 22.07.2008, 12:08
#26
Alaspher


 
Регистрация: 11.10.2004
e•burg
Сообщений: 773


VVA прав на 100% - нельзя начинать учиться игре в шахматы по партиям профессионалов (а приведённый Алексеем код - как раз этого уровня). Начинать надо с простейших примеров для начинающих, тем более, что почти все приёмы в них можно отработать не хуже, чем в самых замысловатых экзерсисах, но гораздо нагляднее. Предложенное задание с "колонной" - само то. Причём писать надо так, чтобы потом программу легко было дополнить например запросом и обработкой угла поворота "колонны". Для этого надо чётко разделять блок ввода с контролем корректности ввода, блок вычислений и блок рисования. Все блоки можно (и нужно) оформить в отдельные функции. Причём каждый блок может так же быть разделён на ещё более простые отдельные функции... Кажущаяся простота задачи обманчива. Разница между кодом уровня "лишь бы как-то..." и "качественный рабочий" велика чрезвычайно.
Alaspher вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Непрочитано 22.07.2008, 12:20
#27
VVA

Инженер LISP
 
Регистрация: 11.05.2005
Минск
Сообщений: 6,542
Отправить сообщение для VVA с помощью ICQ Отправить сообщение для VVA с помощью Skype™


Про поворот колонны как раз было у меня в планах дальше
__________________
Как использовать код на Лиспе читаем здесь
VVA вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Непрочитано 22.07.2008, 12:24
#28
Alaspher


 
Регистрация: 11.10.2004
e•burg
Сообщений: 773


Сорри, что спалил!
Alaspher вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Автор темы   Непрочитано 22.07.2008, 12:42
#29
Red Nova

ՃԱՐՏԱՐԱԳԵՏ, Տ.Գ.Թ.
 
Регистрация: 23.10.2007
Торонто
Сообщений: 1,952
Отправить сообщение для Red Nova с помощью Skype™


VVA,

Знаешь ведь, что по любому не сумею.
Ну хоть предположу, что на счет запроса ширины надо начать так, а что дальше, это пока для меня не реально.
Код:
[Выделить все]
(defun C:Колонна (/ newstring)
  (setq newstring (getstring T "Введите ширину колонны <Выход>: "))
И то признаюсь, что скопировал с существующего лиспа
Похоже я пока еще ниже уровнем чем даже ты предположил.
__________________
Блог
Red Nova вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Непрочитано 22.07.2008, 12:51
#30
Shoorup

Автоматика и Телемеханика на железнодорожном транспорте
 
Регистрация: 16.09.2006
Минск
Сообщений: 1,582
Отправить сообщение для Shoorup с помощью ICQ Отправить сообщение для Shoorup с помощью Skype™


Red Nova, я такой же "позорник" который до сих пор лиспом не владеет
Мне вот тоже не помешало бы научиться...но то времени нет то желание пропадает то опять появляется...
Книги у меня есть и не одна а толку мало...

Может нам профессионалы тут будут давать практические задания, а мы попробуем учитьсяна них. Просто по голой книге учиться тяжело... А вот с "репетиторами"... Что скажите?
__________________
Поезд который устал от ржавого здравомыслия рельсов...
Shoorup вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Непрочитано 22.07.2008, 12:53
#31
Shoorup

Автоматика и Телемеханика на железнодорожном транспорте
 
Регистрация: 16.09.2006
Минск
Сообщений: 1,582
Отправить сообщение для Shoorup с помощью ICQ Отправить сообщение для Shoorup с помощью Skype™


Например давайте попробуем написать программу складывающие 2 числа хранящиеся в однострочном тексте а результат поместить в 3й текст.
Какие функции необходимо использовать для такой программы?
ЗЫ. программу нужно не оптимизированную, а максимально простую для понимания. без vl- vla- vlr и пр.
ЗЗЫ. Также мне кажется не нужно писать нам готовую программу а потом ее разбирать. Нужно только показать куда копать и чем, естественно помагая в ошибках.
__________________
Поезд который устал от ржавого здравомыслия рельсов...
Shoorup вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Автор темы   Непрочитано 22.07.2008, 12:59
#32
Red Nova

ՃԱՐՏԱՐԱԳԵՏ, Տ.Գ.Թ.
 
Регистрация: 23.10.2007
Торонто
Сообщений: 1,952
Отправить сообщение для Red Nova с помощью Skype™


Shoorup,
У меня в последнее время есть и желание и время, только способностей маловато. По книге и я ничего не понимаю, вот и создал тему, с просьбой мастерам показать примеры на практике.

Давай пока разберем пример от VVA (#25), потом приступим к твоему.
__________________
Блог
Red Nova вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Непрочитано 22.07.2008, 13:03
#33
Shoorup

Автоматика и Телемеханика на железнодорожном транспорте
 
Регистрация: 16.09.2006
Минск
Сообщений: 1,582
Отправить сообщение для Shoorup с помощью ICQ Отправить сообщение для Shoorup с помощью Skype™


Red Nova, была тут похожая тема но там уже не совсем чайника учили. И вообще было кучу тем типа с чего начать и помогите и ляляля
__________________
Поезд который устал от ржавого здравомыслия рельсов...
Shoorup вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Непрочитано 22.07.2008, 13:08
#34
VVA

Инженер LISP
 
Регистрация: 11.05.2005
Минск
Сообщений: 6,542
Отправить сообщение для VVA с помощью ICQ Отправить сообщение для VVA с помощью Skype™


Начало правильное.
Ширина колонны - число (будем считать всегда целое). Поэтому надо запросить не строку (getstring), а число. Найди нужное из ряда get* функций.
Давай переменным будем давать осознанные имена. Newstring как-то не вяжится с шириной и числом вообще
__________________
Как использовать код на Лиспе читаем здесь
VVA вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Непрочитано 22.07.2008, 13:38
#35
Shoorup

Автоматика и Телемеханика на железнодорожном транспорте
 
Регистрация: 16.09.2006
Минск
Сообщений: 1,582
Отправить сообщение для Shoorup с помощью ICQ Отправить сообщение для Shoorup с помощью Skype™


подскажите мне по задаче из 31го поста.
Необходимые мне функции:
+ складывать чтобы
atof - для преобразования строки в вещественное число
numberp - для проверки. число выбрано или чтото другое
ssget - для того чтобы получить список.
Что еще забыл? и вообще правильно ли выбрал?
__________________
Поезд который устал от ржавого здравомыслия рельсов...
Shoorup вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Автор темы   Непрочитано 22.07.2008, 14:12
#36
Red Nova

ՃԱՐՏԱՐԱԳԵՏ, Տ.Գ.Թ.
 
Регистрация: 23.10.2007
Торонто
Сообщений: 1,952
Отправить сообщение для Red Nova с помощью Skype™


VVA,
Цитата:
Найди нужное из ряда get* функций.
А где взять перечень этих функций?
__________________
Блог
Red Nova вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Непрочитано 22.07.2008, 14:15
#37
Shoorup

Автоматика и Телемеханика на железнодорожном транспорте
 
Регистрация: 16.09.2006
Минск
Сообщений: 1,582
Отправить сообщение для Shoorup с помощью ICQ Отправить сообщение для Shoorup с помощью Skype™


Red Nova, Купи книгу Полещука AutoLISP и Visual LISP в среде AutoCAD.
__________________
Поезд который устал от ржавого здравомыслия рельсов...
Shoorup вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Непрочитано 22.07.2008, 14:19
#38
Shoorup

Автоматика и Телемеханика на железнодорожном транспорте
 
Регистрация: 16.09.2006
Минск
Сообщений: 1,582
Отправить сообщение для Shoorup с помощью ICQ Отправить сообщение для Shoorup с помощью Skype™


Цитата:
Сообщение от VVA Посмотреть сообщение
Начало правильное.
Ширина колонны - число (будем считать всегда целое). Поэтому надо запросить не строку (getstring), а число. Найди нужное из ряда get* функций.
Давай переменным будем давать осознанные имена. Newstring как-то не вяжится с шириной и числом вообще
VVA, наверно это getint?или getreal...
__________________
Поезд который устал от ржавого здравомыслия рельсов...
Shoorup вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Непрочитано 22.07.2008, 14:31
#39
Кулик Алексей aka kpblc
Moderator

LISP, C# (ACAD 200[9,12,13,14])
 
Регистрация: 25.08.2003
С.-Петербург
Сообщений: 34,811


А также getsrting, getpoint
В дополнение к #33: http://dwg.ru/f/showthread.php?t=5650 и http://dwg.ru/f/showthread.php?t=5887
__________________

---
Обращение ко мне - на "ты".
Все, что сказано - личное мнение.
Кулик Алексей aka kpblc вне форума вставить имя Обратить внимание модератора на это сообщение  
 
Непрочитано 22.07.2008, 14:31
#40
Post

конструктор
 
Регистрация: 29.07.2005
Ростов-на-Дону
Сообщений: 1,078
Отправить сообщение для Post с помощью ICQ


В dnl есть книга Финкельштейн "Autocad библия пользователя", так на диске к этой книге есть дополнительные главы про лисп как раз с такого типа примерами как колонна. Я по ней смог что-то для кружочков с цифрами буквами написать (маркеры осей) и еще такого типа. Дальше, к сожалению, не продвинулся. Там доступно и на примерах объясняют основы... Если в dnl нет диска к книге напишите - я выложу.
__________________
С уважением!!!
Post вне форума вставить имя Обратить внимание модератора на это сообщение  
Ответ
Вернуться   Форум DWG.RU > Программное обеспечение > Программирование > LISP > Научите лиспу на примере (или как kpblc, VVA и компания пытаются обучить чайника лиспу)

Инженерные консультации
Опции темы Поиск в этой теме
Поиск в этой теме:

Расширенный поиск

Быстрый переход

Похожие темы
Тема Автор Раздел Ответов Последнее сообщение
LISP. Вставка в таблицу поля, соотвествующего площади примитива Profan Готовые программы 256 07.08.2017 11:53
Сейсмозащита и сейсмоизоляция существующих, построенных зд. IANationalInformAgentstvo Прочее. Архитектура и строительство 216 20.01.2015 16:51
Мониторы LCD CRT Разное 94 17.06.2008 10:51
ЮМОР 2006 =) Perezz!! Разное 1122 04.01.2007 00:46

|| Главная || Каталог САПР || Тендеры || Публикации || Объявления || Биржа труда || Download || Галерея ||
|| Библиотека || Кунсткамера || Каталог предприятий || Контакты || Файлообменник || Блоги ||


Размещение рекламы